unit BrickletRotaryPoti;

{$ifdef FPC}{$mode OBJFPC}{$endif}

interface

uses
  IPConnection, LEConverter;

type
  TBrickletRotaryPotiNotifyPosition = procedure(const position: smallint) of object;

  TBrickletRotaryPoti = class(TDevice)
  private
    positionCallback: TBrickletRotaryPotiNotifyPosition;
    procedure CallbackWrapperPosition(const packet: TByteArray);
  public
    constructor Create(const uid_: string);
    procedure SetPositionCallbackPeriod(const period: longword);
    property OnPosition: TBrickletRotaryPotiNotifyPosition read positionCallback write positionCallback;
  end;

implementation

constructor TBrickletRotaryPoti.Create(const uid_: string);
begin
  inherited Create(uid_);
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[13] := {$ifdef FPC}@{$endif}CallbackWrapperPosition;
end;

procedure TBrickletRotaryPoti.SetPositionCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := ipcon.CreateRequest(stackID, 3, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletRotaryPoti.CallbackWrapperPosition(const packet: TByteArray);
var position: smallint;
begin
  if assigned(positionCallback) then begin
    position := LEConvertInt16From(4, packet);
    positionCallback(position);
  end;
end;

end.
